    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * --------------------
    028     * XIntervalSeries.java
    029     * --------------------
    030     * (C) Copyright 2006-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 20-Oct-2006 : Version 1 (DG);
    038     * 11-Apr-2008 : Added getXLowValue() and getXHighValue() methods (DG);
    039     *
    040     */
    041
    042    package org.jfree.data.xy;
    043
    044    import org.jfree.data.ComparableObjectItem;
    045    import org.jfree.data.ComparableObjectSeries;
    046
    047    /**
    048     * A list of (x, x-low, x-high, y) data items.
    049     *
    050     * @since 1.0.3
    051     *
    052     * @see XIntervalSeriesCollection
    053     */
    054    public class XIntervalSeries extends ComparableObjectSeries {
    055
    056        /**
    057         * Creates a new empty series.  By default, items added to the series will
    058         * be sorted into ascending order by x-value, and duplicate x-values will
    059         * be allowed (these defaults can be modified with another constructor.
    060         *
    061         * @param key  the series key (<code>null</code> not permitted).
    062         */
    063        public XIntervalSeries(Comparable key) {
    064            this(key, true, true);
    065        }
    066
    067        /**
    068         * Constructs a new xy-series that contains no data.  You can specify
    069         * whether or not duplicate x-values are allowed for the series.
    070         *
    071         * @param key  the series key (<code>null</code> not permitted).
    072         * @param autoSort  a flag that controls whether or not the items in the
    073         *                  series are sorted.
    074         * @param allowDuplicateXValues  a flag that controls whether duplicate
    075         *                               x-values are allowed.
    076         */
    077        public XIntervalSeries(Comparable key, boolean autoSort,
    078                boolean allowDuplicateXValues) {
    079            super(key, autoSort, allowDuplicateXValues);
    080        }
    081
    082        /**
    083         * Adds a data item to the series.
    084         *
    085         * @param x  the x-value.
    086         * @param y  the y-value.
    087         * @param xLow  the lower bound of the y-interval.
    088         * @param xHigh  the upper bound of the y-interval.
    089         */
    090        public void add(double x, double xLow, double xHigh, double y) {
    091            super.add(new XIntervalDataItem(x, xLow, xHigh, y), true);
    092        }
    093
    094        /**
    095         * Returns the x-value for the specified item.
    096         *
    097         * @param index  the item index.
    098         *
    099         * @return The x-value (never <code>null</code>).
    100         */
    101        public Number getX(int index) {
    102            XIntervalDataItem item = (XIntervalDataItem) getDataItem(index);
    103            return item.getX();
    104        }
    105
    106        /**
    107         * Returns the lower bound of the x-interval for the specified item.
    108         *
    109         * @param index  the item index.
    110         *
    111         * @return The lower bound of the x-interval.
    112         *
    113         * @since 1.0.10
    114         */
    115        public double getXLowValue(int index) {
    116            XIntervalDataItem item = (XIntervalDataItem) getDataItem(index);
    117            return item.getXLowValue();
    118        }
    119
    120        /**
    121         * Returns the upper bound of the x-interval for the specified item.
    122         *
    123         * @param index  the item index.
    124         *
    125         * @return The upper bound of the x-interval.
    126         *
    127         * @since 1.0.10
    128         */
    129        public double getXHighValue(int index) {
    130            XIntervalDataItem item = (XIntervalDataItem) getDataItem(index);
    131            return item.getXHighValue();
    132        }
    133
    134        /**
    135         * Returns the y-value for the specified item.
    136         *
    137         * @param index  the item index.
    138         *
    139         * @return The y-value.
    140         */
    141        public double getYValue(int index) {
    142            XIntervalDataItem item = (XIntervalDataItem) getDataItem(index);
    143            return item.getYValue();
    144        }
    145
    146        /**
    147         * Returns the data item at the specified index.
    148         *
    149         * @param index  the item index.
    150         *
    151         * @return The data item.
    152         */
    153        public ComparableObjectItem getDataItem(int index) {
    154            return super.getDataItem(index);
    155        }
    156
    157    }